/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_interrupt.c
 *
 *	@brief	Windows iTRONT[rXR[ (荞݋@\).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include <process.h>
#include "wi_interrupt.h"

/****************************************************************************
 *
 * 荞݃Xbhւ̃bZ[W.
 *
 ****************************************************************************/
#define	WM_SYSTEM_EXIT	(WM_USER + 1)		//!< VXȅI.
#define	WM_INTRRUPT_REQ	(WM_USER + 2)		//!< 荞ݗv.

/****************************************************************************
 *
 * [J֐`.
 *
 ****************************************************************************/
static unsigned int __stdcall	IntrTask( void* arg );
static void			CallIntrruptHandler( INT no );

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR		*ObjList;			//!< 荞݃nhXg̃|C^.
static HANDLE		IntrThread;			//!< 荞݃Xbh̃nh.
static DWORD		IntrTid;			//!< 荞݃Xbh̎ʎq.
static BOOL			CpuLockFlg;			//!< TRUE = CPUbN.

/****************************************************************************/
/*!
 *	@brief	荞݋@\̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitInterrupt( void )
{
	unsigned int tid;

	ObjList    = NULL;
	IntrThread = NULL;
	IntrTid    = 0;
	CpuLockFlg = FALSE;

	//! 荞݃XbhN.
	IntrThread = (HANDLE)_beginthreadex( NULL, 0, &IntrTask, NULL, 0, &tid );

	//! ^XN̗Dxݒ肷.
	SetThreadPriority( IntrThread, THREAD_PRIORITY_HIGHEST );

}

/****************************************************************************/
/*!
 *	@brief	荞݋@\̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitInterrupt( void )
{
	WIHDR		*next_ptr;
	WIINTOBJ	*p;

	//! VXeǗXbhI.
	if( IntrThread ){
		//! 荞݃XbhɏIʒm.
		PostThreadMessage( IntrTid, WM_SYSTEM_EXIT, 0, 0 );

		//! - Xbh~̂mF.
		wi_DormantThread( IntrThread, 1000 );

		//! - 荞݃Xbh̃nh.
		CloseHandle( IntrThread );
	}
	p = (WIINTOBJ *)ObjList;
	while( p ){
		next_ptr = p->Hdr.Next;

		//! 荞݃nh\̂.
		SAFE_RELEASE( p );

		//! ̊荞݃nh\̂o.
		p = (WIINTOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	荞݃nh̒`.
 *
 *	@param	[in]	no		荞݃nhԍ.
 *	@param	[in]	obj		荞݃nh.IuWFNg\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_DefineIntrruptHander( INT no, const WIINTOBJ *obj )
{
	ER			ercd;
	WIINTOBJ	*p;

	//! ɐĂnhԍ̏ꍇ̓GgAhXXV.
	p = (WIINTOBJ *)wi_GetObject( no, ObjList );
	if( p ){
		p->IntrAdr = obj->IntrAdr;
		p->Enabled = FALSE;
		p->IntrCnt = 0;
		return E_OK;
	}
	//! 荞݃nhIuWFNg쐬.
	p = (WIINTOBJ *)wi_CreateObject( no, TMAX_MAXINT, sizeof(WIINTOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgɊ荞݃nhǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	荞݂̋֎~.
 *
 *	@param	[in]	no		荞݃nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DisableIntrrupt( INT no )
{
	ER			ercd;
	WIINTOBJ	*p;

	//! nhԍ̃IuWFNg擾.
	p = (WIINTOBJ *)wi_FindObject( no, TMAX_MAXINT, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! 荞݂֎~.
	p->Enabled = FALSE;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	荞݂̋.
 *
 *	@param	[in]	no		荞݃nhԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_EnableIntrrupt( INT no )
{
	ER			ercd;
	WIINTOBJ	*p;

	//! nhԍ̃IuWFNg擾.
	p = (WIINTOBJ *)wi_FindObject( no, TMAX_MAXINT, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! 荞݂.
	p->Enabled = TRUE;

	//! 荞݂ۗĂꍇ͊荞݂𔭐.
	if( p->IntrCnt > 0 ){
		wi_IntrruptRequest( no );
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	CPUbNԂւ̈ڍs.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		wi_LockCPU( void )
{
	//! CPUbNtOZbg.
	CpuLockFlg = TRUE;

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	CPUbNԂ̉.
 *
 *	@param	Ȃ.
 *
 *	@retval	G[R[h.
 */
ER		wi_UnLockCPU( void )
{
	//! CPUbNtO.
	CpuLockFlg = FALSE;

	//! ۗĂ荞݃nȟĂяos.
	wi_DelayedIntrrupt();

	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	CPUbNԂ̎Q.
 *
 *	@param	Ȃ.
 *
 *	@retval	TRUE = CPUbN. / FALSE = CPU񃍃bN.
 */
BOOL	wi_IsCPULock( void )
{
	return CpuLockFlg;
}

/****************************************************************************/
/*!
 *	@brief	ۗĂ荞݃nȟĂяos.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_DelayedIntrrupt( void )
{
	WIINTOBJ *p = (WIINTOBJ *)ObjList;
	while( p ){
		//! 荞݂ۗĂꍇ͊荞݂𔭐.
		if( p->IntrCnt > 0 ){
			wi_IntrruptRequest( p->Hdr.Id );
		}
		p = (WIINTOBJ *)p->Hdr.Next;
	}
}

/****************************************************************************/
/*!
 *	@brief	荞݂𔭐.
 *
 *	@param	[in]	no		荞݃nhԍ.
 *
 *	@retval	Ȃ.
 */
void	wi_IntrruptRequest( INT no )
{
	if( IntrTid ){
		PostThreadMessage( IntrTid, WM_INTRRUPT_REQ, (WPARAM)no, 0 );
	}
}

/****************************************************************************/
/*!
 *	@brief	荞ݗvNA.
 *
 *	@param	[in]	no		荞݃nhԍ.
 *
 *	@retval	Ȃ.
 */
void	wi_ClearIntrruptRequest( INT no )
{
	ER			ercd;
	WIINTOBJ	*p;

	//! nhԍ̃IuWFNg擾.
	p = (WIINTOBJ *)wi_FindObject( no, TMAX_MAXINT, ObjList, &ercd );
	if( p ){
		//! 荞ݗvNA.
		p->IntrCnt = 0;
	}
}

/****************************************************************************/
/*!
 *	@brief	荞݃^XN.
 *
 *	@param	[in]	arg		^XN\[X\̂̃|C^.
 *
 *	@retval	0Ԃ.
 */
static unsigned __stdcall IntrTask( void* arg )
{
	MSG	msg;

	//! Xbhʎq擾.
	IntrTid = GetCurrentThreadId();

	//! bZ[W[v.
	while( GetMessage( &msg, NULL, 0, 0 ) ){

		//! VXȅȈꍇ̓bZ[W[v𔲂.
		if( msg.message == WM_SYSTEM_EXIT ){
			break;
		}
		switch( msg.message ){
		case WM_INTRRUPT_REQ:
			CallIntrruptHandler( (INT)msg.wParam );
			break;
		}
	}
	_endthreadex( 0 );
	return 0;
}

/****************************************************************************/
/*!
 *	@brief	荞݃nhĂяo.
 *
 *	@param	[in]	no		荞݃nhԍ.
 *
 *	@retval	Ȃ.
 */
static void		CallIntrruptHandler( INT no )
{
	wi_CommonLock();
	do {
		FP			intr_adr;
		ER			ercd;
		WIINTOBJ	*p;

		//! 荞݃nh\̂o.
		p = (WIINTOBJ *)wi_FindObject( no, TMAX_MAXINT, ObjList, &ercd );
		if( !p ){
			break;
		}
		//! 荞݃GgAhXȂꍇ͌ĂяoȂ.
		if( !p->IntrAdr ){
			break;
		}
		//! 荞݋֎~̏ꍇ͌ĂяoȂ.
		if( !p->Enabled || wi_IsCPULock() ){
			p->IntrCnt++;
			break;
		}
		p->IntrCnt = 0;

		intr_adr = p->IntrAdr;

		wi_CommonUnlock();

		//! 荞݃nhĂяo.
		intr_adr();
		return;

	} while( FALSE );

	wi_CommonUnlock();
}

/* End of file */
