/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	wi_mail_box.c
 *
 *	@brief	Windows iTRONT[rXR[ ([{bNX).
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include "wi_mail_box.h"

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static WIHDR	*ObjList;			//!< [{bNXXg̃|C^.

/****************************************************************************/
/*!
 *	@brief	[{bNXǗ̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_InitMailBox( void )
{
	ObjList = NULL;
}

/****************************************************************************/
/*!
 *	@brief	[{bNXǗ̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	wi_QuitMailBox( void )
{
	WIHDR		*next_ptr;
	WIMBXOBJ	*p = (WIMBXOBJ *)ObjList;

	while( p ){
		next_ptr = p->Hdr.Next;

		//! [{bNXIuWFNg\̂.
		SAFE_RELEASE( p );

		//! ̃[{bNXIuWFNg\̂o.
		p = (WIMBXOBJ *)next_ptr;
	}
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̐.
 *
 *	@param	[in]	id		[{bNXIDԍ.
 *	@param	[in]	obj		[{bNXIuWFNg\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_CreateMailBox( INT id, const WIMBXOBJ *obj )
{
	ER			ercd;
	WIMBXOBJ	*p;

	//! sȈ̏ꍇ̓G[ɂ.
	if( (obj->Attribute & TA_MPRI) != 0 && (obj->MaxPriority == 0 || obj->MaxPriority > TMAX_MPRI) ){
		return E_PAR;
	}
	//! [{bNXIuWFNg쐬.
	p = (WIMBXOBJ *)wi_CreateObject( id, TMAX_MAXMBX, sizeof(WIMBXOBJ), obj, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgɃ[{bNXǉ.
	wi_AddObject( (WIHDR *)p, &ObjList );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̍폜.
 *
 *	@param	[in]	id		[{bNXIDԍ.
 *
 *	@retval	G[R[h.
 */
ER		wi_DeleteMailBox( INT id )
{
	ER			ercd;
	WIMBXOBJ	*p;

	//! [{bNXID̃IuWFNg擾.
	p = (WIMBXOBJ *)wi_FindObject( id, TMAX_MAXMBX, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! XgY郁[{bNX菜.
	wi_DelObject( (WIHDR *)p, &ObjList );

	//! ҂^XNL[.
	wi_WakeupDelResource( p->WaitQue );

	//! [{bNXIuWFNg\̂.
	SAFE_RELEASE( p );
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	[{bNXւ̑M.
 *
 *	@param	[in]	id		[{bNXIDԍ.
 *	@param	[in]	msg		bZ[WpPbg̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_SendMailBox( INT id, T_MSG *msg )
{
	ER			ercd;
	WIMBXOBJ	*p;
	T_MSG		*msg_ptr;

	//! [{bNXID̃IuWFNg擾.
	p = (WIMBXOBJ *)wi_FindObject( id, TMAX_MAXMBX, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȈ̏ꍇ̓G[ɂ.
	if( !msg ){
		return E_PAR;
	}
	msg->nextmsg = NULL;
	if( (p->Attribute & TA_MPRI) != 0 ){
		//! DxɃbZ[Wi[ꍇ.
		if( !(p->MsgQue) ){
			//! bZ[WL[ɃbZ[WȂꍇ̓bZ[WL[̐擪Ɋi[.
			p->MsgQue = msg;
		}else
		if( p->MsgQue->msgpri > msg->msgpri ){
			//! bZ[WL[̐擪bZ[WDxꍇbZ[WL[̐擪Ɋi[.
			msg->nextmsg = p->MsgQue;
			p->MsgQue    = msg;
		}else{
			msg_ptr = p->MsgQue;
			while( msg_ptr ){
				if( !(msg_ptr->nextmsg) ){
					//! ̃bZ[WȂꍇ̓bZ[WL[̍ŌɃbZ[Wi[.
					msg_ptr->nextmsg = msg;
					break;
				}
				if( msg_ptr->nextmsg->msgpri > msg->msgpri ){
					//! ̃bZ[WDxꍇÃbZ[W̑OɃbZ[Wi[.
					msg->nextmsg     = msg_ptr->nextmsg;
					msg_ptr->nextmsg = msg->nextmsg;
					break;
				}
				msg_ptr = msg_ptr->nextmsg;
			}
		}
	}else{
		//! bZ[WpPbgXgɃNĂŌ̃bZ[WT.
		msg_ptr = p->MsgQue;
		while( msg_ptr ){
			if( !(msg_ptr->nextmsg) ){
				break;
			}
			msg_ptr = msg_ptr->nextmsg;
		}
		//! bZ[WpPbgXg̍ŌɈ̃bZ[WpPbgǉ.
		if( msg_ptr ){
			msg_ptr->nextmsg = msg;
		}else{
			p->MsgQue = msg;
		}
	}
	//! bZ[W҂Ă^XNꍇ̓^XNN.
	if( p->WaitQue ){
		wi_TaskWakeup( p->WaitQue->Id, TTW_MBX, &(p->WaitQue) );
	}
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̎M.
 *
 *	@param	[in]	id		[{bNXIDԍ.
 *	@param	[out]	ppk_msg	bZ[WpPbg̃AhXi[̈̃|C^.
 *	@param	[in]	tmout	^CAEgݒ.
 *
 *	@retval	G[R[h.
 */
ER		wi_ReceiveMailBox( INT id, T_MSG **msg, TMO tmout )
{
	ER			ercd;
	WIMBXOBJ	*p;

	//! [{bNXID̃IuWFNg擾.
	p = (WIMBXOBJ *)wi_FindObject( id, TMAX_MAXMBX, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! sȈ̏ꍇ̓G[ɂ.
	if( !msg ){
		return E_PAR;
	}
	//! bZ[WpPbgXgɃbZ[Wꍇ̓bZ[WoďI.
	if( p->MsgQue ){
		*msg      = p->MsgQue;
		p->MsgQue = p->MsgQue->nextmsg;
		return E_OK;
	}
	//! bZ[WM܂Ń^XNX[v.
	ercd = wi_TaskWait( id, TTW_MBX, tmout, p->Attribute, &(p->WaitQue) );
	if( ercd == E_OK ){
		if( p->MsgQue ){
			*msg      = p->MsgQue;
			p->MsgQue = p->MsgQue->nextmsg;
		}
	}
	return ercd;
}

/****************************************************************************/
/*!
 *	@brief	[{bNX̏ԎQ.
 *
 *	@param	[in]	id		[{bNXIDԍ.
 *	@param	[out]	sts		[{bNXԂi[\̂̃|C^.
 *
 *	@retval	G[R[h.
 */
ER		wi_RefarenceMailBox( INT id, WIMBXSTAT *sts )
{
	ER			ercd;
	WIMBXOBJ	*p;

	//! [{bNXID̃IuWFNg擾.
	p = (WIMBXOBJ *)wi_FindObject( id, TMAX_MAXMBX, ObjList, &ercd );
	if( !p ){
		return ercd;
	}
	//! [{bNX̏Ԃ\̂ɃZbg.
	sts->WaitId  = wi_GetWaitTaskListFirstId( p->WaitQue );
	sts->NextMsg = p->MsgQue;
	sts->ExtInfo = p->ExtInfo;
	return E_OK;
}

/****************************************************************************/
/*!
 *	@brief	폜^XN҂s񂩂폜.
 *
 *	@param	[in]	id		폜^XNIDԍ.
 *
 *	@retval	Ȃ.
 */
void	wi_AllReleaseMailBox( INT id )
{
	WIMBXOBJ *p;

	for( p = (WIMBXOBJ *)ObjList; p; p = (WIMBXOBJ *)p->Hdr.Next ){

		//! 폜^XN҂s񂩂폜.
		p->WaitQue = wi_DelWaitTaskList( id, p->WaitQue );
	}
}

/* End of file */
