/****************************************************************************
 *	Copylight(C) 2007-2011 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	kprintf.c
 *
 *	@brief	fobOj^ENCAǧJ֐.
 *
 *	@author	V 閾
 */
#include <windows.h>
#include "kprintf.h"

#ifdef  __cplusplus
extern "C" {
#endif

#ifdef	_UNICODE
static int			dummy_kprintf( const wchar_t *fmt, ... );
#else
static int			dummy_kprintf( const char *fmt, ... );
#endif

static HINSTANCE	DllInstance = NULL;			//!< DLL̃CX^XEnh.
KDBMONPROC			kprintf = dummy_kprintf;

/****************************************************************************/
/*!
 *	@brief	fobOj^ENCAgN.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	kprint_init( void )
{
	KDBMONPROC	proc;

#ifdef	_UNICODE
	DllInstance = LoadLibrary( L"kprint.dll" );
#else
	DllInstance = LoadLibrary( "kprint.dll" );
#endif
	if( !DllInstance ){
		kprintf = dummy_kprintf;
		return;
	}
#ifdef	_UNICODE
	proc = (KDBMONPROC)GetProcAddress( DllInstance, "kwprintf" );
#else
	proc = (KDBMONPROC)GetProcAddress( DllInstance, "kprintf" );
#endif
	if( !proc ){
		kprintf = dummy_kprintf;
		return;
	}
	kprintf = proc;
}

/****************************************************************************/
/*!
 *	@brief	fobOj^ENCAgI.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
void	kprint_exit( void )
{
	kprintf = dummy_kprintf;

	if( DllInstance ){
		FreeLibrary( DllInstance );
		DllInstance = NULL;
	}
}

#ifdef	_UNICODE
/****************************************************************************/
/*!
 *	@brief	DLLƂ̃_~[֐ (UNICODEp).
 *
 *	@param	[in]	fmt		tbZ[W̃|C^.
 *
 *	@retval	bZ[W̃oCg.(0Ԃ)
 */
static int	dummy_kprintf( const wchar_t *fmt, ... )
{
	return 0;
}
#else
/****************************************************************************/
/*!
 *	@brief	DLLƂ̃_~[֐ (ANSIp).
 *
 *	@param	[in]	fmt		tbZ[W̃|C^.
 *
 *	@retval	bZ[W̃oCg.(0Ԃ)
 */
static int	dummy_kprintf( const char *fmt, ... )
{
	return 0;
}
#endif

#ifdef  __cplusplus
}
#endif

/* End of file */
