/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	win_itron4.h
 *
 *	@brief	Windows iTRON(Ver4.0)T[rXR[.
 *
 *	@author	V 閾
 */
#ifndef	__WIN_ITRON4_H__
#define	__WIN_ITRON4_H__

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************************
 *
 * f[^^Cv.
 *
 ****************************************************************************/
typedef int				INT;			//!< t.
typedef unsigned int	UINT;			//!< .
typedef	void			*VP;			//!< |C^ϐ.
typedef void			(*FP)();		//!< ֐GgAhX.
typedef	VP				VP_INT;			//!< VP ܂ INT.
typedef	INT				ER;				//!< G[R[h.
typedef	INT				HNO;			//!< nhԍ.
typedef	INT				RDVNO;			//!< fuԍ.
typedef	INT				ID;				//!< IDԍ.
typedef	UINT			ATR;			//!< .
typedef	INT				PRI;			//!< ^XNDx.
typedef	INT				FN;				//!< t@NVR[h.
typedef	INT				ER_UINT;		//!< G[R[h ܂ UINT.
typedef	INT				ER_ID;			//!< G[R[h ܂ ID.
typedef UINT			STAT;			//!< .
typedef UINT			INTNO;			//!< 荞ݔԍ.
typedef	UINT			TEXPTN;			//!< ^XNOv.
typedef	UINT			FLGPTN;			//!< CxgtOp^[.
typedef	UINT			RDVPTN;			//!< fu.
typedef	UINT			MODE;			//!< ҂[h.

/*!
 *
 * @brief ^C}\.
 *
 */
typedef struct
{
	short				utime;			//!< 16rbg.
    unsigned long		ltime;			//!< 32rbg.
} SYSTIME;

typedef	SYSTIME			RELTIM;			//!< nh̎.
typedef	SYSTIME			CYCTIME;		//!< nh̎.
typedef	SYSTIME			ALMTIME;		//!< A[nh̎.
typedef	long			DLYTIME;		//!< ^XNfBC.
typedef	long			TMO;			//!< ^CAEgݒl.

#define	TASK			void			//!< ^XN̊֐^Cv.
#define TMRHDR			void			//!< ^C}nh̊֐^Cv.
#define INTHDR			void			//!< 荞݃nh̊֐^Cv.

/****************************************************************************
 *
 * V{`.
 *
 ****************************************************************************/
//! IuWFNg̑.
#define TA_ASM	 	0x0000				//!< AZuɂvO.
#define TA_HLNG 	0x0001				//!< ɂvO.
#define	TA_ACT		0x0002				//!< ^XNシɋN.
#define TA_TFIFO	0x0000				//!< ҂^XNFIFO.
#define TA_TPRI 	0x0001				//!< ҂^XN͗Dx.

//! ^CAEgݒ.
#define TMO_POL 	0					//!< |[O.
#define TMO_FEVR	(-1)				//!< iv҂.

/****************************************************************************
 *
 * G[R[h.
 *
 ****************************************************************************/
#define E_OK		0					//!< I.
#define E_SYS		(-5)				//!< VXeG[.
#define E_NOSPT 	(-9)				//!< T|[g@\.
#define E_RSFN		(-10)				//!< \@\R[hԍ.
#define E_RSATR 	(-11)				//!< \񑮐.
#define E_PAR		(-17)				//!< p[^G[.
#define E_ID		(-18)				//!< sIDԍ.
#define E_CTX		(-25)				//!< ReLXgG[.
#define E_MACV		(-26)				//!< ANZXs\AANZXᔽ.
#define E_OACV		(-27)				//!< IuWFNgANZXᔽ.
#define E_ILUSE		(-28)				//!< T[rXR[sgp.
#define E_NOMEM 	(-33)				//!< s.
#define E_NOID	 	(-34)				//!< IDԍs.
#define E_OBJ		(-41)				//!< IuWFNg̏Ԃs.
#define E_NOEXS 	(-42)				//!< IuWFNg݂Ȃ.
#define E_QOVR		(-43)				//!< L[CO܂̓lXg̃I[o[t[.
#define E_RLWAI 	(-49)				//!< ҂ԋ.
#define E_TMOUT 	(-50)				//!< |[Os܂̓^CAEg.
#define E_DLT		(-51)				//!< ҂IuWFNg폜ꂽ.
#define E_CLS		(-52)				//!< ҂IuWFNg̏Ԃω.
#define E_WBLK		(-57)				//!< mubLOt.
#define E_BOVR		(-58)				//!< obt@I[o[t[.

/****************************************************************************
 *
 * ^XNǗ@\.
 *
 ****************************************************************************/
/*!
 *
 * @brief ^XN\.
 *
 */
typedef struct {
	ATR			tskatr;				//!< ^XN̑.
	VP_INT		exinf;				//!< g.
	FP			task;				//!< X^[gAhX.
	PRI			itskpri;			//!< ̃^XNDx.
	INT			stksz;				//!< X^bNTCY.
	VP			stk;				//!< X^bN̈̐擪AhX.
} T_CTSK;

/*!
 *
 * @brief ^XNԂ̎QƗp\.
 *
 */
typedef struct {
	STAT		tskstat;			//!< ^XN.
	PRI			tskpri; 			//!< ݂̗Dx.
	PRI			tskbpri; 			//!< x[XDx.
	STAT		tskwait;			//!< ҂v.
	ID			wobjid; 			//!< ҂IuWFNgID.
	TMO			lefttmo;			//!< ^CAEg܂ł̎.
	UINT		actcnt;				//!< NvJEg.
	UINT		wupcnt;				//!< NvJEg.
	UINT		suscnt;				//!< TXyhvJEg.
} T_RTSK;

/*!
 *
 * @brief ^XNԂ̎QƗp\ (ȈՔ).
 *
 */
typedef struct {
	STAT		tskstat;			//!< ^XN.
	STAT		tskwait;			//!< ҂v.
} T_RTST;

/*!
 *
 * @brief ^XNO̒`p\.
 *
 */
typedef struct {
	ATR			texatr;				//!< ^XNO[`̑.
	FP			texrtn;				//!< ^XNO[`̃X^[gAhX.
} T_DTEX;

/*!
 *
 * @brief ^XNOԂ̎QƗp\.
 *
 */
typedef struct {
	STAT		texstat;			//!< ^XNȌ.
	TEXPTN		pndptn; 			//!< ۗOv.
} T_RTEX;

/*!
 *
 * @brief ^XNIDݒl.
 *
 */
#define TSK_SELF	0				//!< ^XNw.
 
/*!
 *
 * @brief ^XNDx(tskpri).
 *
 */
#define TPRI_INI	0				//!< ^XNN̏Dxw (chg_pri).
#define TPRI_RUN	0				//!< ̎s̍ōDxw (rot_rdq).

/*!
 *
 * @brief ^XNs(tskstat).
 *
 */
#define	TTS_RUN 	0x0001			//!< ^XNs.
#define	TTS_RDY 	0x0002			//!< ^XNs\.
#define	TTS_WAI 	0x0004			//!< ^XN҂.
#define	TTS_SUS 	0x0008			//!< ҂.
#define	TTS_WAS 	0x000C			//!< d҂.
#define	TTS_DMT 	0x0010			//!< ^XNx~.

/*!
 *
 * @brief ^XN҂v(tskwait).
 *
 */
#define TTW_SLP 	0x0001			//!< N҂.
#define TTW_DLY 	0x0002			//!< Ԍoߑ҂.
#define TTW_SEM 	0x0004			//!< Z}tHl҂.
#define TTW_FLG 	0x0008			//!< CxgtO҂.
#define TTW_SDTQ 	0x0010			//!< f[^L[ւ̑M҂.
#define TTW_RDTQ 	0x0020			//!< f[^L[̎M҂.
#define TTW_MBX 	0x0040			//!< [{bNX̎M҂.
#define TTW_MTX 	0x0080			//!< ~[ebNX̃bN҂.
#define TTW_SMBF	0x0100			//!< bZ[Wobt@ւ̑M҂.
#define TTW_RMBF	0x0200			//!< bZ[Wobt@̎M҂.
#define TTW_CAL 	0x0400			//!< fuďo҂.
#define TTW_ACP 	0x0800			//!< fut҂.
#define TTW_RDV 	0x1000			//!< fuI҂.
#define TTW_MPF 	0x2000			//!< Œ蒷ubN̊l҂.
#define TTW_MPL 	0x4000			//!< ϒubN̊l҂.

// T[rXR[̒`.
ER		cre_tsk( ID tskid, const T_CTSK *pk_ctsk );
ER_ID	acre_tsk( const T_CTSK *pk_ctsk );
ER		del_tsk( ID tskid );
ER		act_tsk( ID tskid );
ER		iact_tsk( ID tskid );
ER_UINT	can_act( ID tskid );
ER		sta_tsk( ID tskid, VP_INT stacd );
void	ext_tsk( void );
void	exd_tsk( void );
ER		ter_tsk( ID tskid );
ER		chg_pri( ID tskid, PRI tskpri );
ER		get_pri( ID tskid, PRI *p_tskpri );
ER		ref_tsk( ID tskid, T_RTSK *pk_rtsk );
ER		ref_tst( ID tskid, T_RTST *pk_rtst );
ER		slp_tsk( void );
ER		tslp_tsk( TMO tmout );
ER		wup_tsk( ID tskid );
ER		iwup_tsk( ID tskid );
ER_UINT	can_wup( ID tskid );
ER		rel_wai( ID tskid );
ER		irel_wai( ID tskid );
ER		sus_tsk( ID tskid );
ER		rsm_tsk( ID tskid );
ER		frsm_tsk( ID tskid );
ER		dly_tsk( RELTIM dlytim );
ER		def_tex( ID tskid, T_DTEX *pk_dtex );
ER		ras_tex( ID tskid, TEXPTN rasptn );
ER		iras_tex( ID tskid, TEXPTN rasptn );
ER		dis_tex( void );
ER		ena_tex( void );
INT		sns_tex( void );
ER		ref_tex( ID tskid, T_RTEX *pk_rtex );

/****************************************************************************
 *
 * ʐM@\ (Z}tH).
 *
 ****************************************************************************/
/*!
 *
 * @brief Z}tH\.
 *
 */
typedef struct {
	ATR			sematr;				//!< Z}tH̑.
	UINT		isemcnt;			//!< Z}tH̏l.
	UINT		maxsem; 			//!< Z}tH̍ől.
} T_CSEM;

/*!
 *
 * @brief Z}tHԂ̎QƗp\.
 *
 */
typedef struct {
	ID 			wtskid;				//!< Z}tH҂s̐擪̃^XNIDԍ.
	UINT		semcnt;				//!< ݂̃Z}tHJEgl.
} T_RSEM;

// T[rXR[̒`.
ER		cre_sem( ID semid, const T_CSEM *pk_csem );
ER_ID	acre_sem( const T_CSEM *pk_csem );
ER		del_sem( ID semid );
ER		sig_sem( ID semid );
ER		isig_sem( ID semid );
ER		wai_sem( ID semid );
ER		pol_sem( ID semid );
ER		twai_sem( ID semid, TMO tmout );
ER		ref_sem( ID semid, T_RSEM *pk_rsem );

/****************************************************************************
 *
 * ʐM@\ (CxgtO).
 *
 ****************************************************************************/
/*!
 *
 * @brief CxgtO\.
 *
 */
typedef struct {
	ATR			flgatr;				//!< CxgtȎ.
	FLGPTN		iflgptn;			//!< CxgtȌl.
} T_CFLG;

/*!
 *
 * @brief CxgtOԂ̎QƗp\.
 *
 */
typedef struct {
	ID 			wtskid;				//!< CxgtO҂s̐擪̃^XNIDԍ.
	FLGPTN		flgptn;				//!< CxgtÕrbgp^[.
} T_RFLG;

/*!
 *
 * @brief CxgtO(flgatr).
 *
 */
#define TA_WSGL 	0x0000			//!< ^XN̑҂Ȃ.
#define TA_WMUL 	0x0002			//!< ^XN̑҂.
#define	TA_CLR		0x0004			//!< tOp^[̃NA.

/*!
 *
 * @brief CxgtȎ҂(wfmode).
 *
 */
#define	TWF_ANDW	0x0000			//!< AND҂.
#define	TWF_ORW 	0x0002			//!< OR҂.
#define	TWF_CLR 	0x0001			//!< NAw.

// T[rXR[̒`.
ER		cre_flg( ID flgid, const T_CFLG *pk_cflg );
ER_ID	acre_flg( const T_CFLG *pk_cflg );
ER		del_flg( ID flgid );
ER		set_flg( ID flgid, FLGPTN setptn );
ER		iset_flg( ID flgid, FLGPTN setptn );
ER		clr_flg( ID flgid, FLGPTN clrptn );
ER		wai_flg( ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn );
ER		pol_flg( ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn );
ER		twai_flg( ID flgid, FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout );
ER		ref_flg( ID flgid, T_RFLG *pk_rflg );

/****************************************************************************
 *
 * ʐM@\ (f[^L[).
 *
 ****************************************************************************/
/*!
 *
 * @brief f[^L[\.
 *
 */
typedef struct {
	ATR			dtqatr;				//!< f[^L[̑.
	UINT		dtqcnt;				//!< f[^L[̈̌.
	VP			dtq;				//!< f[^L[̈̐擪AhX.
} T_CDTQ;

/*!
 *
 * @brief f[^L[Ԃ̎QƗp\.
 *
 */
typedef struct {
	ID 			stskid;				//!< f[^L[̑M҂s̐擪̃^XNIDԍ.
	ID 			rtskid;				//!< f[^L[̎M҂s̐擪̃^XNIDԍ.
	UINT		sdtqcnt;			//!< f[^L[ɓĂf[^.
} T_RDTQ;

// T[rXR[̒`.
ER		cre_dtq( ID dtqid, const T_CDTQ *pk_cdtq );
ER_ID	acre_dtq( const T_CDTQ *pk_cdtq );
ER		del_dtq( ID dtqid );
ER		snd_dtq( ID dtqid, VP_INT data );
ER		psnd_dtq( ID dtqid, VP_INT data );
ER		ipsnd_dtq( ID dtqid, VP_INT data );
ER		tsnd_dtq( ID dtqid, VP_INT data, TMO tmout );
ER		fsnd_dtq( ID dtqid, VP_INT data );
ER		ifsnd_dtq( ID dtqid, VP_INT data );
ER		rcv_dtq( ID dtqid, VP_INT *p_data );
ER		prcv_dtq( ID dtqid, VP_INT *p_data );
ER		trcv_dtq( ID dtqid, VP_INT *p_data, TMO tmout );
ER		ref_dtq( ID dtqid, T_RDTQ *pk_rdtq );

/****************************************************************************
 *
 * ʐM@\ ([{bNX).
 *
 ****************************************************************************/
/*!
 *
 * @brief bZ[WpPbg\.
 *
 */
typedef struct _T_MSG {
	struct _T_MSG	*nextmsg;		//!< ̃bZ[WpPbg\̂̃|C^.
	PRI				msgpri;			//!< bZ[W̗Dx.
} T_MSG;

/*!
 *
 * @brief [{bNX\.
 *
 */
typedef struct {
	ATR			mbxatr;				//!< [{bNX̑.
	PRI			maxmpri;			//!< M郁bZ[WDx̍ől.
	VP			mprihd;				//!< Dxʂ̃bZ[WL[wb_̈̃AhX.
} T_CMBX;

/*!
 *
 * @brief [{bNXԂ̎QƗp\.
 *
 */
typedef struct {
	ID 			wtskid;				//!< [{bNX҂s̐擪̃^XNIDԍ.
	T_MSG		*pk_msg;			//!< bZ[WL[̐擪̃bZ[WpPbg̃AhX.
} T_RMBX;

/*!
 *
 * @brief [{bNX(mbxatr).
 *
 */
#define TA_MFIFO	0x0000			//!< bZ[WFIFO.
#define TA_MPRI 	0x0002			//!< bZ[W͗Dx.

// T[rXR[̒`.
ER		cre_mbx( ID mbxid, const T_CMBX *pk_cmbx );
ER_ID	acre_mbx( const T_CMBX *pk_cmbx );
ER		del_mbx( ID mbxid );
ER		snd_msg( ID mbxid, T_MSG *pk_msg );
ER		rcv_msg( ID mbxid, T_MSG **ppk_msg );
ER		prcv_msg( ID mbxid, T_MSG **ppk_msg );
ER		trcv_msg( ID mbxid, T_MSG **ppk_msg, TMO tmout );
ER		ref_mbx( ID mbxid, T_RMBX *pk_rmbx );

/****************************************************************************
 *
 * gʐM@\ (~[ebNX).
 *
 ****************************************************************************/
/*!
 *
 * @brief ~[ebNX\.
 *
 */
typedef struct {
	ATR			mtxatr; 			//!< ~[ebNX̑.
	PRI			ceilpri;			//!< ~[ebNX̏Dx.
} T_CMTX;

/*!
 *
 * @brief ~[ebNXԂ̎QƗp\.
 *
 */
typedef struct {
	ID			htskid;				//!< ~[ebNXbNĂ^XNIDԍ.
	ID			wtskid;				//!< ~[ebNX҂s̐擪̃^XNIDԍ.
} T_RMTX;

#define	TA_INHERIT		0x02		//!< DxpvgR.
#define	TA_CEILING		0x03		//!< DxvgR.

// T[rXR[̒`.
ER		cre_mtx( ID mtxid, const T_CMTX *pk_cmtx );
ER_ID	acre_mtx( const T_CMTX *pk_cmtx );
ER		del_mtx( ID mtxid );
ER		loc_mtx( ID mtxid );
ER		ploc_mtx( ID mtxid );
ER		tloc_mtx( ID mtxid, TMO tmout );
ER		unl_mtx( ID mtxid );
ER		ref_mtx( ID mtxid, T_RMTX *pk_rmtx );

/****************************************************************************
 *
 * gʐM@\ (bZ[Wobt@).
 *
 ****************************************************************************/
/*!
 *
 * @brief bZ[Wobt@\.
 *
 */
typedef struct {
	ATR				mbfatr; 		//!< bZ[Wobt@̑.
	UINT			maxmsz; 		//!< bZ[W̍őTCY.
	/*SIZE*/ UINT	mbfsz;			//!< bZ[Wobt@̈̃TCY.
	VP				mbf;			//!< bZ[Wobt@̈̃AhX.
} T_CMBF;

/*!
 *
 * @brief bZ[Wobt@Ԃ̎QƗp\.
 *
 */
typedef struct {
	ID 			stskid;				//!< bZ[Wobt@̑M҂s̐擪̃^XNIDԍ.
	ID 			rtskid;				//!< bZ[Wobt@̎M҂s̐擪̃^XNIDԍ.
	INT			smsgcnt;			//!< bZ[Wobt@ɓĂ郁bZ[W̐.
	INT			fmbfsz;				//!< bZ[Wobt@̋󂫗̈̃TCY.
} T_RMBF;

// T[rXR[̒`.
ER		cre_mbf( ID mbfid, const T_CMBF *pk_cmbf );
ER_ID	acre_mbf( const T_CMBF *pk_cmbf );
ER		del_mbf( ID mbfid );
ER		snd_mbf( ID mbfid, VP msg, UINT msgsz );
ER		psnd_mbf( ID mbfid, VP msg, UINT msgsz );
ER		tsnd_mbf( ID mbfid, VP msg, UINT msgsz, TMO tmout );
ER_UINT	rcv_mbf( ID mbfid, VP msg );
ER_UINT	prcv_mbf( ID mbfid, VP msg );
ER_UINT	trcv_mbf( ID mbfid, VP msg, TMO tmout );
ER		ref_mbf( ID mbfid, T_RMBF *pk_rmbf );

/****************************************************************************
 *
 * gʐM@\ (fu).
 *
 ****************************************************************************/
/*!
 *
 * @brief fu|[g\.
 *
 */
typedef struct {
	ATR			poratr; 			//!< fu|[g̑.
	UINT		maxcmsz;			//!< ďõbZ[W̍ő咷.
	UINT		maxrmsz;			//!< ԓ̃bZ[W̍ő咷.
} T_CPOR;

/*!
 *
 * @brief fu|[gԂ̎QƗp\.
 *
 */
typedef struct {
	ID 			ctskid;				//!< fu|[ǧďo҂s̐擪̃^XNIDԍ.
	ID 			atskid;				//!< fu|[g̎t҂s̐擪̃^XNIDԍ.
} T_RPOR;

/*!
 *
 * @brief fuԂ̎QƗp\.
 *
 */
typedef struct {
	ID 			wtskid;				//!< fuI҂Ԃ̃^XNIDԍ.
} T_RRDV;

// T[rXR[̒`.
ER		cre_por( ID porid, const T_CPOR *pk_cpor );
ER_ID	acre_por( const T_CPOR *pk_cpor );
ER		del_por( ID porid );
ER_UINT	cal_por( ID porid, RDVPTN calptn, VP msg, UINT cmsgsz );
ER_UINT	tcal_por( ID porid, RDVPTN calptn, VP msg, UINT cmsgsz, TMO tmout );
ER_UINT	acp_por( ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg );
ER_UINT	pacp_por( ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg );
ER_UINT	tacp_por( ID porid, RDVPTN acpptn, RDVNO *p_rdvno, VP msg, TMO tmout );
ER		fwd_por( ID porid, RDVPTN calptn, RDVNO rdvno, VP msg, UINT cmsgsz );
ER		rpl_rdv( RDVNO rdvno, VP msg, UINT cmsgsz );
ER		ref_por( ID porid, T_RPOR *pk_rpor );
ER		ref_rdv( RDVNO rdvno, T_RRDV *pk_rrdv );

/****************************************************************************
 *
 * v[Ǘ@\ (Œ蒷v[).
 *
 ****************************************************************************/
/*!
 *
 * @brief Œ蒷v[\.
 *
 */
typedef struct {
	ATR			mpfatr; 			//!< Œ蒷v[̑.
	UINT		blkcnt; 			//!< mۂł郁ubN.
	UINT		blfsz;				//!< ubÑTCY.
	VP			mpf;				//!< Œ蒷v[̈̃AhX.
} T_CMPF;

/*!
 *
 * @brief Œ蒷v[Ԃ̎QƗp\.
 *
 */
typedef struct {
	ID 			wtskid;				//!< Œ蒷v[̑҂s̐擪̃^XNIDԍ.
	UINT		fblkcnt; 			//!< 󂫃ubŇ.
} T_RMPF;

// T[rXR[̒`.
ER		cre_mpf( ID mpfid, const T_CMPF *pk_cmpf );
ER_ID	acre_mpf( const T_CMPF *pk_cmpf );
ER		del_mpf( ID mpfid );
ER		get_blf(ID mpfid, VP *p_blf );
ER		pget_blf(ID mpfid, VP *p_blf );
ER		tget_blf(ID mpfid, VP *p_blf, TMO tmout );
ER		rel_blf( ID mpfid, VP blk );
ER		ref_mpf( ID mpfid, T_RMPF *pk_rmpf );

/****************************************************************************
 *
 * v[Ǘ@\ (ϒv[).
 *
 ****************************************************************************/
/*!
 *
 * @brief ϒv[\.
 *
 */
typedef struct {
	ATR				mplatr; 		//!< ϒv[.
	INT	/*SIZE*/	mplsz;			//!< ϒv[̃TCY.
	VP				mpl;			//!< ϒv[̈̃AhX.
} T_CMPL; 

/*!
 *
 * @brief ϒv[Ԃ̎QƗp\.
 *
 */
typedef struct
{
	ID 				wtskid;			//!< ϒv[̑҂s̐擪̃^XNIDԍ.
	INT	/*SIZE*/	fmplsz;			//!< ϒv[̋󂫗̈̍vTCY.
	UINT			fblksz;			//!< l\ȍő̘A󂫗̈̃TCY.
} T_RMPL; 


// T[rXR[̒`.
ER		cre_mpl( ID mplid , const T_CMPL *pk_cmpl );
ER		acre_mpl( const T_CMPL *pk_cmpl );
ER		del_mpl( ID mplid );
ER		get_mpl( ID mplid, UINT blksz, VP *p_blk );
ER		pget_mpl( ID mplid, UINT blksz, VP *p_blk );
ER		tget_mpl( ID mplid, UINT blksz, VP *p_blk, TMO tmout );
ER		rel_blk( ID mpfid, VP blk );
ER		ref_mpl( ID mplid, T_RMPL *pk_rmpl );

/****************************************************************************
 *
 * ԊǗ@\.
 *
 ****************************************************************************/

// T[rXR[̒`.
ER		set_tim( const SYSTIME *pk_tim );
ER		get_tim( SYSTIME *pk_tim );
ER		isig_tim( void );

#define	ret_tmr()	return;

/****************************************************************************
 *
 * ԊǗ@\ (nh).
 *
 ****************************************************************************/
/*!
 *
 * @brief nh`p\.
 *
 */
typedef struct {
	ATR			cycatr; 			//!< nh.
	VP_INT		exinf;				//!< g.
	FP			cychdr;				//!< nh̃AhX.
	RELTIM		cyctim; 			//!< NԊԊu.
	RELTIM		cycphs; 			//!< Nʑ.
} T_CCYC;

/*!
 *
 * @brief nhԂ̎QƗp\.
 *
 */
typedef struct {
	STAT		cycstat;			//!< nh̓.
	RELTIM		lefttim; 			//!< ̋N܂ł̎.
} T_RCYC;

/*!
 *
 * @brief nh̓(cycstat).
 *
 */
#define	TCYC_STP		0x00		//!< nh삵ĂȂ.
#define	TCYC_STA		0x01		//!< nh삵Ă.

#define	TA_STA			0x02		//!< nhN.
#define	TA_PHS			0x04		//!< nh̋Nʑ.

// T[rXR[̒`.
ER		cre_cyc( ID cycid, const T_CCYC *pk_ccyc );
ER		acre_cyc( const T_CCYC *pk_ccyc );
ER		del_cyc( ID cycid );
ER		sta_cyc( ID cycid );
ER		stp_cyc( ID cycid );
ER		ref_cyc( ID cycid, T_RCYC *pk_rcyc );

/****************************************************************************
 *
 * ԊǗ@\ (A[nh).
 *
 ****************************************************************************/
/*!
 *
 * @brief A[nh`p\.
 *
 */
typedef struct {
	ATR			almatr; 			//!< A[nh.
	VP_INT		exinf;				//!< g.
	FP			almhdr;				//!< A[nh̃AhX.
} T_CALM;

/*!
 *
 * @brief A[nhԂ̎QƗp\.
 *
 */
typedef struct {
	STAT		almstat;			//!< A[nh̓.
	RELTIM		lefttim; 			//!< A[nh̋N܂ł̎.
} T_RALM;

/*!
 *
 * @brief Nw胂[h(tmmode).
 *
 */
#define TTM_ABS 	0x0000			//!< Ύł̎w.
#define TTM_REL 	0x0001			//!< Ύł̎w.

/*!
 *
 * @brief A[nh̓(almstat).
 *
 */
#define	TALM_STP		0x00		//!< A[nh삵ĂȂ.
#define	TALM_STA		0x01		//!< A[nh삵Ă.

// T[rXR[̒`.
ER		cre_alm( ID almid, const T_CALM *pk_calm );
ER_ID	acre_alm( const T_CALM *pk_calm );
ER		del_alm( ID almid );
ER		sta_alm( ID almid, RELTIM almtim );
ER		stp_alm( ID almid );
ER		ref_alm( ID almid, T_RALM *pk_ralm );

/****************************************************************************
 *
 * 荞݊Ǘ@\.
 *
 ****************************************************************************/
/*!
 *
 * @brief ݃nh`p\.
 *
 */
typedef struct {
	ATR			inhatr; 			//!< ݃nh.
	FP			inthdr;				//!< ݃nhAhX.
} T_DINH;

// T[rXR[̒`.
ER		def_inh( INTNO intno, const T_DINH *pk_dinh );
ER		dis_int( INTNO intno );
ER		ena_int( INTNO intno );
ER		loc_cpu( void );
ER		unl_cpu( void );

/****************************************************************************
 *
 * VXeǗ@\.
 *
 ****************************************************************************/
/*!
 *
 * @brief o[W\.
 *
 */
typedef struct {
	unsigned short	maker;			//!< [J[.
	unsigned short	prid;			//!< J[l̎ʔԍ.
	unsigned short	spver;			//!< dlo[W.
	unsigned short	prver;			//!< J[l̃o[Wԍ.
	unsigned short	prno[4];		//!< iǗ.
} T_RVER;

/*!
 *
 * @brief VXe\.
 *
 */
typedef struct {
	INT			sysstat;			//!< VXe.
} T_RSYS;
 
/*!
 *
 * @brief RtBO[V\.
 *
 */
typedef struct {
	VP			dummy;				//!< `݂̂̂߃_~[̃oϐ`.
} T_RCFG;

/*!
 *
 * @brief VXe(sysstat).
 *
 */
#define TSS_TSK 	0				//!< ^XNsŃfBXpb`ʏ̏.
#define TSS_DDSP	1				//!< ^XNsdis_dsps̏(fBXpb`֎~).
#define TSS_LOC 	3				//!< ^XNsloc_cpus̏(݂уfBXpb`֎~).
#define TSS_INDP	4				//!< ^XNƗ(荞݃nhA^C}nh)s.

// T[rXR[̒`.
ER		rot_rdq( PRI tskpri );
ER		get_tid( ID *p_tskid );
ER		dis_dsp( void );
ER		ena_dsp( void );
ER		ref_sys( T_RSYS *pk_rsys );
ER		get_ver( T_RVER *pk_rver );
ER		ref_cfg( T_RCFG *pk_rcfg );

#ifdef __cplusplus
}
#endif
#endif	// __WIN_ITRON4_H__
/* End of file */
