/****************************************************************************
 *	Copylight(C) 2011-2012 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	win_itron_main.c
 *
 *	@brief	Windows iTRONT[rXR[̃C[`.
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include <process.h>
#include "kprintf.h"
#include "win_itron.h"
#include "wi_task.h"
#include "wi_semaphore.h"
#include "wi_event_flag.h"
#include "wi_mail_box.h"
#include "wi_message_buffer.h"
#include "wi_rendezvous_port.h"
#include "wi_fixed_mempool.h"
#include "wi_variable_mempool.h"
#include "wi_cycle_handler.h"
#include "wi_alarm_handler.h"
#include "wi_interrupt.h"
#include "wi_systemmgr.h"
#include "win_itron_dialog.h"

/****************************************************************************
 *
 * VXeǗXbhւ̃bZ[W.
 *
 ****************************************************************************/
#define	WM_SYSTEM_EXIT	(WM_USER + 1)		//!< VXȅI.
#define	WM_DELETE_TASK	(WM_USER + 2)		//!< ^XN̍폜.

/****************************************************************************
 *
 * [J֐`.
 *
 ****************************************************************************/
static BOOL			WinITRON_Init( void );
static void			WinITRON_Quit( void );
static unsigned int __stdcall SystemTask( void* arg );
static TASK			InitTask( VP_INT stacd );

/****************************************************************************
 *
 * [Jϐ`.
 *
 ****************************************************************************/
static HANDLE	SystemThread = NULL;		//!< VXeǗXbh̃nh.
static DWORD	ThreadId     = 0;			//!< VXeǗXbh̎ʎq.

/****************************************************************************/
/*!
 *	@brief	AvP[VEC.
 *
 *	@param	[in]	hInst		݂̃CX^X̃nh.
 *	@param	[in]	hPreInst	ȑÕCX^X̃nh.
 *	@param	[in]	CmdLine		R}hC.
 *	@param	[in]	show		\.
 *
 *	@retval	0Ԃ.
 */
int WINAPI	WinMain( HINSTANCE hInst, HINSTANCE hPreInst, LPSTR CmdLine, int show )
{
	#ifdef __ITRON3__
	static const T_CTSK	ctsk = { NULL, TA_HLNG, InitTask, 1, 0 };
	#else
	static const T_CTSK	ctsk = { TA_HLNG, NULL, InitTask, 1, 0, NULL };
	#endif

	kprint_init();

	//! iTRONT[rXR[̏.
	if( WinITRON_Init() ){

		//! AvP[V̋N^XN𐶐.
		cre_tsk( TMAX_MAXTSK - 1, &ctsk );

		//! ^XNN.
		sta_tsk( TMAX_MAXTSK - 1, 0 );

		//! _CAON.
		OpenMainDialog( hInst );

		//! iTRONT[rXR[̏I.
		WinITRON_Quit();
	}
	kprintf( "Bye !!\n" );
	kprint_exit();
	return 0;
}

/****************************************************************************/
/*!
 *	@brief	iTRONT[rXR[̏.
 *
 *	@param	Ȃ.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		WinITRON_Init( void )
{
	unsigned int tid;

	//! VXeǗXbhN.
	SystemThread = (HANDLE)_beginthreadex( NULL, 0, &SystemTask, NULL, 0, &tid );

	//! ^XN̗Dxݒ肷.
	SetThreadPriority( SystemThread, THREAD_PRIORITY_HIGHEST );

	//! vZX̗D揇ʃNXʏ̃AvP[V菭Ⴍ.
	if( !SetPriorityClass( GetCurrentProcess(), BELOW_NORMAL_PRIORITY_CLASS ) ){
		return FALSE;
	}
	//! VXeԊǗ@\̏.
	wi_InitSysMgr();

	//! 荞݋@\̏.
	wi_InitInterrupt();

	//! ʊ֐̏.
	if( !wi_CommonInit() ){
		return FALSE;
	}
	//! 荞݋@\̏.
	wi_InitInterrupt();

	//! ^XNǗ̏.
	wi_InitTask();

	//! Z}tH̏.
	wi_InitSemaphore();

	//! CxgtȌ.
	wi_InitEvFlag();

	//! [{bNX̏.
	wi_InitMailBox();

	//! bZ[Wobt@̏.
	wi_InitMsgBuffer();

	//! Œ蒷v[̏.
	wi_InitFixedMemPool();

	//! ϒv[̏.
	wi_InitVarMemPool();

	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	iTRONT[rXR[̏I.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		WinITRON_Quit( void )
{
	//! VXeǗXbhI.
	if( SystemThread ){
		//! - VXeǗXbhɏIʒm.
		PostThreadMessage( ThreadId, WM_SYSTEM_EXIT, 0, 0 );

		//! - Xbh~̂mF.
		wi_DormantThread( SystemThread, 1000 );

		//! - VXeǗXbh̃nh.
		CloseHandle( SystemThread );
	}
	//! VXeԊǗ@\̏I.
	wi_QuitSysMgr();

	//! 荞݋@\̏I.
	wi_QuitInterrupt();

	//! ^XNǗ̏I.
	wi_QuitTask();

	//! Z}tH̏I.
	wi_QuitSemaphore();

	//! CxgtȌI.
	wi_QuitEvFlag();

	//! [{bNX̏I.
	wi_QuitMailBox();

	//! bZ[Wobt@̏I.
	wi_QuitMsgBuffer();

	//! Œ蒷v[̏I.
	wi_QuitFixedMemPool();

	//! ϒv[̏I.
	wi_QuitVarMemPool();

	//! ʊ֐̏I.
	wi_CommonQuit();
}

/****************************************************************************/
/*!
 *	@brief	[U[AvP[V̋N^XN.
 *
 *	@param	[in]	stacd	^XN̋NR[h.
 *
 *	@retval	Ȃ.
 */
static TASK		InitTask( VP_INT stacd )
{
	//! [U[AvP[V̋N.
	startup_target();
}

/****************************************************************************/
/*!
 *	@brief	荞݂𔭐.
 *
 *	@param	[in]	num		荞݃nhԍ.
 *
 *	@retval	Ȃ.
 */
void	request_interrupt( UINT num )
{
	wi_IntrruptRequest( num );
}

/****************************************************************************/
/*!
 *	@brief	荞ݗvNA.
 *
 *	@param	[in]	no		荞݃nhԍ.
 *
 *	@retval	Ȃ.
 */
void	clear_interrupt_request( UINT num )
{
	wi_ClearIntrruptRequest( num );
}

/****************************************************************************/
/*!
 *	@brief	VXeǗ^XNɃ^XN\[X̍폜v.
 *
 *	@param	[in]	id		^XNIDʎq.
 *
 *	@retval	Ȃ.
 */
void	wi_DeleteTaskReq( ID id )
{
	if( ThreadId ){
		PostThreadMessage( ThreadId, WM_DELETE_TASK, (WPARAM)id, 0 );
	}
}

/****************************************************************************/
/*!
 *	@brief	VXeǗ^XN.
 *
 *	@param	[in]	arg		^XN\[X\̂̃|C^.
 *
 *	@retval	0Ԃ.
 */
static unsigned __stdcall SystemTask( void* arg )
{
	MSG	msg;

	//! Xbhʎq擾.
	ThreadId = GetCurrentThreadId();

	//! bZ[W[v.
	while( GetMessage( &msg, NULL, 0, 0 ) ){

		//! VXȅȈꍇ̓bZ[W[v𔲂.
		if( msg.message == WM_SYSTEM_EXIT ){
			break;
		}
		switch( msg.message ){
		case WM_DELETE_TASK:
			del_tsk( (ID)msg.wParam );
			break;
		}
	}
	_endthreadex( 0 );
	return 0;
}

/* End of file */
